

#include "flottant_impl.hh"
#include "erreur.hh"


//
// Ceci est l'implantation de la classe
// specifiee dans flottant_impl.hh
// Peu de choses a dire ici : c'est du C++ standard
// Un point interessant : voir l'utilisation des exceptions
// dans les methode "empiler" et "depiler".



flottant_impl::flottant_impl(int taille)
{
	donnees=new CORBA::Double[taille];
	if(donnees==NULL)
		ERREUR(FALSE,"Pb alloc pile\n");

	sommet=-1;
	tailleMax=taille;
}


flottant_impl::~flottant_impl()
{
	delete donnees;
}


CORBA::Long flottant_impl::taillePile(void)
{
	return tailleMax;
}


CORBA::Long flottant_impl::empileDonnee (CORBA::Double  donnee)
{
	empiler(donnee);	
	return(sommet+1);
}


CORBA::Long flottant_impl::empileOperateur (polonaise::ope  operation)
{
	double operande1=depiler();
	double operande2=depiler();

	switch(operation)		
		{
		case polonaise::addition:		empiler(operande1+operande2);
							break;
		case polonaise::soustraction:		empiler(operande1-operande2);
							break;
		case polonaise::division:		empiler(operande1/operande2);
							break;
		case polonaise::multiplication:		empiler(operande1*operande2);
							break;
		}
	return(sommet+1);
}


CORBA::Long flottant_impl::depileResultat (CORBA::Double& res)
{
	res=depiler();
	return(sommet+1);
}


CORBA::Double flottant_impl::depiler(void)
{
	CORBA::Double res;

	if(sommet==-1)
		throw polonaise::erreur(polonaise::pileVide);
	else	{
		res=donnees[sommet];
		sommet--;
		}
		
	return res;
}

void flottant_impl::empiler(CORBA::Double element)
{
	if(sommet==(tailleMax-1))
		throw polonaise::erreur(polonaise::pilePleine);
	else	{
		sommet++;
		donnees[sommet]=element;
		}
}




