
#ifndef FLOTTANT_H
#define FLOTTANT_H

#include <iostream.h>
#include "polonaise.hh"
#include "bool.hh"


//
//   Cette classe fournie l'implantation de 
//   polonaise.idl
//   Pour chaque attribut et methode du code idl, on
//   specifie une methode dans cette classe
//   Le prototype de chaque methode C++ est standardise
//   par CORBA (voir CORBA 2.1 donc)
//


//
//   L'implantation herite du squelette genere
//   par le compilateur idl
//
class flottant_impl : public virtual polonaise::_sk_flottant {

public:

	// Constructeur : on passe la taille max 
	// de la pile
	flottant_impl(int taille);

	// Destructeur
	~flottant_impl();

	// Methode pour l'implantation de 
	// l'attribut "taillePile"
	CORBA::Long taillePile(void);

	// Puis, les trois methodes
	// de l'interface IDL
	CORBA::Long empileDonnee (CORBA::Double donnee);
	CORBA::Long empileOperateur (polonaise::ope operation);
	CORBA::Long depileResultat (CORBA::Double& res);



//
// Les membres suivants ne sont pas
// exportes pour les clients
//
private:


	// Methodes de service
	// pour gerer la pile
	double depiler(void);
	void empiler(double);

	// Le sommet de la pile
	int sommet;

	// La pile de double
	double* donnees;

	// La taille maximale
	// de la pile
	int tailleMax;
};

#endif


