#include <iostream.h>
#include "polonaise.hh"
#include "nommage.hh"
#include "flottant_impl.hh"


///////////////////////////////////////////////////////
// Le code suivant est celui du serveur
// Il instancie une interface "flottant", puis l'enregistre
// aupres de la BOA et du service de nom
///////////////////////////////////////////////////////



int main(int argc, char **argv)
{




	//
	// Initialisation standard de l'ORB et de la BOA
	//
	CORBA::ORB_ptr orb = CORBA::ORB_init(argc,argv,"omniORB2");
	CORBA::BOA_ptr boa = orb->BOA_init(argc,argv,"omniORB2_BOA");



	// 
	// On instancie une implementation
	// pour une interface flottant
	//
	flottant_impl *obj = new flottant_impl(2);
	if(obj==NULL)
		ERREUR(FALSE,"Pb alloc obj \n");



	// Enregistrement de l'instance aupres de la BOA
	// Cet appel indique a la BOA que l'objet est pret
	//
	boa->obj_is_ready(obj);





	//
	// On exporte maintenant l'IOR de l'interface
	// vers le service de nom CORBA
	//

	// On commence par construire le nom
	// du service a exporter
	//
	CosNaming::Name nomObjet;
	CosNaming::Name nomContexte;

	nomContexte.length(1);
	nomContexte[0].id   = (const char*) "polonaise";   
	nomContexte[0].kind = (const char*) "contexte";
    
	nomObjet.length(1);
	nomObjet[0].id   = (const char*) "flottant";
	nomObjet[0].kind = (const char*) "objet";


	// On recupere la reference d'objet
	//	
	polonaise::flottant_var ref = obj->_this();


	// Et on l'exporte vers le service de nom
        // Afin de simplifier, ce code, toutes les interactions
        // avec le service de nom sont encapsules dans nommage.hh
        // L'operation "import" implante le methode "resolve"
        // du service de nom
        //
	if (!export(orb,nomContexte,nomObjet,ref)) 
		ERREUR(FALSE,"Pb export de l'IOR vers omniNames\n");

  

	// Derniere chose a faire : avertir la BOA
	// que l'implementation est prete a etre invoque
	// impl_is_red() est bloquant


	boa->impl_is_ready();



	return 0;
}

