
#include <stdlib.h>
#include "conversion_impl.hh"
#include "erreur.hh"
#include "ltostr.hh"

//
// Ceci est l'implantation de la classe
// specifiee dans conversion_impl.hh
//



// Methode empileDonnee. La variable "donnees" est la sequence passe en parametre
//			 La methode accede au nombre d'element de "donnees" par "donnees.length()"
//			 et a l'element "i" de "donnees" par "donnees[i]"
??? conversion_impl::empileDonnee(  ??? donnees )   
{
	for(unsigned int i=0;i<donnees.length();i++)
		{
		switch(donnees[i].type)
			{
			case polonaise::decimal: 	empiler(strtol(donnees[i].element,(char**)NULL,10));
							break;
			case polonaise::binaire: 	empiler(strtol(donnees[i].element,(char**)NULL,2));
							break;
			case polonaise::hexadecimal: 	empiler(strtol(donnees[i].element,(char**)NULL,16));
							break;
			}
		} 

	return(sommet+1);
}




// Methode empileOperateur. La variable "op" est la sequence passe en parametre
//			 La methode accede au nombre d'element de "op" par "op.length()"
//			 et a l'element "i" de "op" par "op[i]"
??? conversion_impl::empileOperateur( ??? op)
{

	for(unsigned int i=0;i<op.length();i++)
		{
		long operande1=depiler();
		long operande2=depiler();

		switch(op[i])		
			{
			case polonaise::addition:		empiler(operande1+operande2);
								break;
			case polonaise::soustraction:		empiler(operande1-operande2);
								break;
			case polonaise::division:		empiler(operande1/operande2);
								break;
			case polonaise::multiplication:		empiler(operande1*operande2);
								break;
			}
		}
	return(sommet+1);
}


// Methode depileResultat. La variable "res" est la structure passee en parametre
??? conversion_impl::depileResultat( ??? res)
{

	long resultat=depiler();
	switch(res.type)		
		{
		case polonaise::decimal:		ltostr(resultat,res.element,10);
							break;
		case polonaise::binaire:		ltostr(resultat,res.element,2);
							break;
		case polonaise::hexadecimal:		ltostr(resultat,res.element,16);
							break;
		}
	
	return(sommet+1);
}



//  Methode convertir. Cette methode utilise deux structures en parametres qui
//  			sont "de" et "vers". "de" fournit le nombre et son format a convertir.
//			"vers" donne le format de destination.
//
//			Pour l'implantation de cette methode, on pourra passer par un long
//				comme format intermediaire. A cet effet,
//				strtol (voir le man) et ltostr (voir ltostr.c) peuvent etre
//				utilisee
//
??? convertir( ???   de, ???    vers)
{

}




//
//   Pour l'exercice, vous n avez plus de modification a effectuer
//   apres cette ligne
//




conversion_impl::conversion_impl(int taille)
{
	donnees=new CORBA::Long[taille];
	if(donnees==NULL)
		ERREUR(FALSE,"Pb alloc pile\n");

	sommet=-1;
	tailleMax=taille;
}


conversion_impl::~conversion_impl()
{
	delete donnees;
}


CORBA::Long conversion_impl::taillePile(void)
{
	return tailleMax;
}



CORBA::Long conversion_impl::depiler(void)
{
	CORBA::Long res;

	if(sommet==-1)
		throw polonaise::erreur(polonaise::pileVide);
	else	{
		res=donnees[sommet];
		sommet--;
		}
		
	return res;
}

void conversion_impl::empiler(CORBA::Long element)
{
	if(sommet==(tailleMax-1))
		throw polonaise::erreur(polonaise::pilePleine);
	else	{
		sommet++;
		donnees[sommet]=element;
		}
}




