
#ifndef CONVERSION_H 
#define CONVERSION_H 

#include <iostream.h>
#include "polonaise.hh"
#include "bool.hh"


//
//   Cette classe fournie l'implantation de 
//   l'interface conversion de polonaise.idl
//   Pour chaque attribut et methode du code idl, on
//   specifie une methode dans cette classe
//   Le prototype de chaque methode C++ est standardise
//   par CORBA (voir CORBA 2.1 donc)
//


//
//   L'implantation herite du squelette genere
//   par le compilateur idl
//
class conversion_impl : public virtual polonaise::_sk_conversion {

public:

	// Constructeur : on passe la taille max 
	// de la pile
	conversion_impl(int taille);

	// Destructeur
	~conversion_impl();

	// Methode pour l'implantation de 
	// l'attribut "taillePile"
	CORBA::Long taillePile(void);

	// Puis, les methodes
	// de l'interface IDL
	// (voir polonaise.idl)
	?
	?
	?
	?



//
// Les membres suivants ne sont pas
// exportes pour les clients
//
private:


	// Methodes de service
	// pour gerer la pile
	long depiler(void);
	void empiler(long);

	// Le sommet de la pile
	int sommet;

	// La pile de double
	long* donnees;

	// La taille maximale
	// de la pile
	int tailleMax;
};

#endif


