#include <iostream.h>
#include "polonaise.hh"
#include "nommage.hh"
#include "flottant_impl.hh"
#include "conversion_impl.hh"


///////////////////////////////////////////////////////
// Le code suivant est celui du serveur
// Il instancie une interface "flottant" et "conversion"
// puis les enregistre
// aupres de la BOA et du service de nom
///////////////////////////////////////////////////////



int main(int argc, char **argv)
{

	//
	// Initialisation standard de l'ORB et de la BOA
	//
	CORBA::ORB_ptr orb = CORBA::ORB_init(argc,argv,"omniORB2");
	CORBA::BOA_ptr boa = orb->BOA_init(argc,argv,"omniORB2_BOA");


	// 
	// On instancie une implementation
	// pour une interface flottant
	//
	flottant_impl *flo = new flottant_impl(2);
	if(flo==NULL)
		ERREUR(FALSE,"Pb alloc flo  \n");

	// Enregistrement de l'instance aupres de la BOA
	boa->obj_is_ready(flo);



	//
	// On exporte maintenant l'IOR de l'interface
	// vers le service de nom CORBA
	//

	// On commence par construire le nom
	// du service a exporter
	//
	CosNaming::Name nomObjet;
	CosNaming::Name nomContexte;

	nomContexte.length(1);
	nomContexte[0].id   = (const char*) "polonaise";   
	nomContexte[0].kind = (const char*) "contexte";
    
	nomObjet.length(1);
	nomObjet[0].id   = (const char*) "flottant";
	nomObjet[0].kind = (const char*) "objet";


	// On recupere la reference d'objet
	//	
	polonaise::flottant_var refFlo = flo->_this();


	// Et on l'exporte vers le service de nom
	// (voir les fichiers nommage.cc et nommage.hh)
	//	
	if (!export(orb,nomContexte,nomObjet,refFlo)) 
		ERREUR(FALSE,"Pb export refFlo de l'IOR vers omniNames\n");

  
	// 
	// Et on refait le meme traitement pour l'interface conversion
	//
	conversion_impl *conv = new conversion_impl(10);
	if(conv==NULL)
		ERREUR(FALSE,"Pb alloc conv \n");

	boa->obj_is_ready(conv);

	nomObjet[0].id   = (const char*) "conversion";

	polonaise::conversion_var refConv = conv->_this();

	if (!export(orb,nomContexte,nomObjet,refConv)) 
		ERREUR(FALSE,"Pb export refConv de l'IOR vers omniNames\n");



  
	// Derniere chose a faire : avertir la BOA
	// que l'implementation est prete a etre invoque
	// impl_is_red() est bloquant

	boa->impl_is_ready();



	return 0;
}

