#include <iostream.h>
#include "polonaise.hh"
#include "nommage.hh"
#include "usine_impl.hh"



// La boa CORBA
CORBA::BOA_ptr boa;



///////////////////////////////////////////////////////
// Le code suivant est celui du serveur
// Il instancie une interface "usine"
// puis l'enregistre
// aupres de la BOA et du service de nom
///////////////////////////////////////////////////////



int main(int argc, char **argv)
{

	//
	// Initialisation standard de l'ORB et de la BOA
	//
	CORBA::ORB_ptr orb = CORBA::ORB_init(argc,argv,"omniORB2");
	boa = orb->BOA_init(argc,argv,"omniORB2_BOA");


	// 
	// On instancie une implementation
	// pour une interface usine
	//
	usine_impl *usn = new usine_impl;
	if(usn==NULL)
		ERREUR(FALSE,"Pb alloc usn  \n");

	// Enregistrement de l'instance aupres de la BOA
	boa->obj_is_ready(usn);



	//
	// On exporte maintenant l'IOR de l'interface
	// vers le service de nom CORBA
	//

	// On commence par construire le nom
	// du service a exporter
	//
	CosNaming::Name nomObjet;
	CosNaming::Name nomContexte;

	nomContexte.length(1);
	nomContexte[0].id   = (const char*) "polonaise";   
	nomContexte[0].kind = (const char*) "contexte";
    
	nomObjet.length(1);
	nomObjet[0].id   = (const char*) "usine";
	nomObjet[0].kind = (const char*) "objet";


	// On recupere la reference de l'objet
	//	
	polonaise::usine_var refUsn = usn->_this();


	// Et on l'exporte vers le service de nom
	// (voir les fichiers nommage.cc et nommage.hh)
	//	
	if (!export(orb,nomContexte,nomObjet,refUsn)) 
		ERREUR(FALSE,"Pb export refFlo de l'IOR vers omniNames\n");

  

  
	// Derniere chose a faire : avertir la BOA
	// que l'objet et pret a etre invoque
	// impl_is_red() est bloquant

	boa->impl_is_ready();



	return 0;
}

